from os import path, environ
from commands import getoutput
from subprocess import PIPE, Popen

from interfaces import IXIVDiag
from collector.collectable.files import SimpleFileCollectable as FileItem
from collector.collectable.commands import SimpleCommandCollectable as CommandItem
from collector.collectable.directories import SimpleDirectoryCollectable as DirectoryItem

GETDMPNODE_COMMAND = ['/bin/sh', '-c',"vxdmpadm getdmpnode enclosure=Disk | awk '/Disk/{print $1}' | while read d; do echo $d; vxdmpadm getsubpaths dmpnodename=$d; echo; done"]

class XIVDiag(IXIVDiag):
    def add_collectables(self):
        self.add_collectable_item(FileItem("vxvm-sysboot", 
                                       self.zip_file, '/sbin/init.d/vxvm-sysboot'))
        self.add_collectable_item(FileItem("syslog", self.zip_file,
                                       '/var/adm/syslog/syslog.log' ))
        self.add_collectable_item(CommandItem('dmesg', ['dmesg' , '']))
        self.add_collectable_item(CommandItem("vol_list", 
                                       ['vxdmpadm', 'getdmpnode', 'enclosure=Disk']))
        self.add_collectable_item(CommandItem("multipath", GETDMPNODE_COMMAND))
